unit UnitDemo;

interface

uses
  Windows, sysutils, Classes, Controls, Forms, StdCtrls, Db, DBTables, ExtCtrls,
  Grids, DBGrids, ComCtrls, ToolWin, Menus, Searcher, ImgList;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    Database1: TDatabase;
    DataSource1: TDataSource;
    Memo2: TMemo;
    Panel2: TPanel;
    Label1: TLabel;
    MemoFilter: TMemo;
    Splitter2: TSplitter;
    MemoSQL: TMemo;
    Splitter3: TSplitter;
    Query1: TQuery;
    Searcher1: TSearcher;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    tbSearch: TToolButton;
    tbReset: TToolButton;
    ToolButton4: TToolButton;
    tbAlignment: TToolButton;
    PopupMenu1: TPopupMenu;
    faLeft1: TMenuItem;
    faRight1: TMenuItem;
    faReport1: TMenuItem;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    Label2: TLabel;
    Label3: TLabel;
    lblWeb: TLabel;
    pnlClient: TPanel;
    DBGrid1: TDBGrid;
    rgTypeJoin: TRadioGroup;
    procedure FormShow(Sender: TObject);
    procedure Searcher1Prepare(Sender: TObject; const SQL, SQLWhere: String);
    procedure Query1AfterOpen(DataSet: TDataSet);
    procedure tbSearchClick(Sender: TObject);
    procedure tbResetClick(Sender: TObject);
    procedure faLeft1Click(Sender: TObject);
    procedure lblWebClick(Sender: TObject);
    procedure rgTypeJoinClick(Sender: TObject);
    procedure tbAlignmentClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses ShellApi;

procedure TForm1.FormShow(Sender: TObject);
begin
  { connecting the database }
  //Database1.DriverName := 'MSACCESS';
  Database1.DriverName := 'STANDARD';
  Database1.Params.Clear;
  //Database1.Params.Add('DATABASE NAME=' + ExtractFilePath(Application.EXEName) + 'prova.mdb');
  Database1.Params.Add('PATH=' + ExtractFilePath(Application.EXEName) + '..\base');
  try
    Database1.Open;
  except
    Application.MessageBox('Error in database connection', 'Searcher', MB_ICONERROR);
    Application.Terminate;
    exit;
  end;
  { Searcher base setting }
  Searcher1.Query := Query1;
  Searcher1.FieldAlignment := faLeft;
  Searcher1.TableName :='parts';
  { setting join properties }
  Searcher1.JoinTables.Add('vendors');
  Searcher1.JoinConditions.Add('parts.VendorNo=Vendors.VendorNo');
  { setting searcher fields at run time }
  with Searcher1.SearcherFields.AddField(fkData, 'Parts.PartNo', ftFloat, 0, false) do
  begin
    Searcheable := true;
    Field.DisplayLabel := 'Part.No';
  end;
  with Searcher1.SearcherFields.AddField(fkData, 'Description', ftString, 30, false) do
  begin
    Field.DisplayLabel := 'Description';
    Searcheable := true;
    CaseSensitive := true;
    TypeSearch := tsContaining;
  end;
  with Searcher1.SearcherFields.AddField(fkData, 'Vendors.VendorNo', ftFloat, 0, false) do
  begin
    Searcheable := true;
    Field.DisplayLabel := 'Vendors No';
  end;
  with Searcher1.SearcherFields.AddField(fkData, 'VendorName', ftString, 30, false) do
  begin
    Field.DisplayLabel := 'Vendor Name';
    TypeSearch := tsStartingWith;
    Searcheable := true;
  end;
  Searcher1.Open;
end;

procedure TForm1.Searcher1Prepare(Sender: TObject; const SQL, SQLWhere: String);
begin
  MemoSQL.Lines.Text := SQL;
  beep;
end;

procedure TForm1.Query1AfterOpen(DataSet: TDataSet);
begin
  MemoFilter.Lines.Text := Searcher1.FilterAsText;
end;

procedure TForm1.tbSearchClick(Sender: TObject);
begin
  Searcher1.Search;
end;

procedure TForm1.tbResetClick(Sender: TObject);
begin
  Searcher1.Reset;
end;

procedure TForm1.faLeft1Click(Sender: TObject);
begin
  Searcher1.FieldAlignment := TFieldAlignment(TComponent(Sender).Tag);
  TMenuItem(Sender).Checked := true;
end;

procedure TForm1.lblWebClick(Sender: TObject);
begin
  ShellExecute(0, 'open', pChar(lblWeb.caption), '', '', SW_SHOWNORMAL);
end;

procedure TForm1.rgTypeJoinClick(Sender: TObject);
begin
  Searcher1.JoinType[0] := TTypeJoin(rgTypeJoin.ItemIndex);
end;

procedure TForm1.tbAlignmentClick(Sender: TObject);
begin
  if Searcher1.FieldAlignment=faReport then
    Searcher1.FieldAlignment := faLeft
  else
    Searcher1.FieldAlignment := Succ(Searcher1.FieldAlignment);
  PopupMenu1.Items[Ord(Searcher1.FieldAlignment)].Checked := true;
end;

end.
